import networkx as nx
import numpy as np


# directory = '../graph-sig/data/source/'
directory = '/gpfs/u/home/GPHC/GPHChegd/barn/source/'
datasets = []  # ['amazon', 'aq', 'citation', 'dblp', 'facebook', 'gowalla', 'roadnet', 'web', 'wikipedia']
node_sizes = ['8', '16', '32', '64']

# G = nx.read_edgelist('/gpfs/u/home/GPHC/GPHChegd/barn/source/100/big_graph_100.txt')
G = nx.read_edgelist('data/wikipedia64.txt')
# G = nx.read_edgelist('data/barn/big_graph_0.txt')
counter = 0
num_graphs_per_dataset_node_size = 1000
for dataset in datasets:
    print dataset
    for node_size in node_sizes:
        print node_size
        for i in range(0, num_graphs_per_dataset_node_size):
            graph = nx.read_edgelist(directory + dataset + '/' + node_size + '/' + str(i) + '.txt')
            nodes = {}
            for node in graph.nodes():
                nodes[node] = str(counter) + '_' + dataset[:2] + str(node_size) + '_' + node
                counter += 1
            graph = nx.relabel_nodes(graph, nodes)
            G = nx.compose(G, graph)
        nx.write_edgelist(G, '/gpfs/u/home/GPHC/GPHChegd/barn/source/' + dataset + node_size + '.txt', data=False)
    # nx.write_edgelist(G, 'data/' + dataset + '64.txt', data=False)
    # nx.write_edgelist(G, '/gpfs/u/home/GPHC/GPHChegd/barn/source/' + dataset + '64.txt', data=False)

conn_comps = list(nx.connected_component_subgraphs(G))
print len(conn_comps)  # 3600
print counter  # 103721, 1040916
# edges: 294841, 2951234

for i in range(0, len(conn_comps)*10):
    chosen_comps = np.random.choice(conn_comps, 2, replace=False)
    node1 = np.random.choice(chosen_comps[0].nodes(), 1)[0]
    node2 = np.random.choice(chosen_comps[1].nodes(), 1)[0]
    G.add_edge(node1, node2)
    if i % 1000 == 0:
        print i
    if i % 50000 == 0:
        pass
        # nx.write_edgelist(G, '/gpfs/u/home/GPHC/GPHChegd/barn/source/big_graph_' + str(i) + '.txt', data=False)
        # nx.write_edgelist(G, 'data/big_graph_' + str(i) + '.txt', data=False)

nx.write_edgelist(G, 'data/big_graph1.txt', data=False)
# nx.write_edgelist(G, '/gpfs/u/home/GPHC/GPHChegd/barn/source/100/big_graph_10x.txt', data=False)
print len(list(nx.connected_component_subgraphs(G)))  # 584
