# Read node_lables dict to get prediction
# node id number and actual label are obtained from current node id naming scheme
# lens size is obtained from the filename
# is_central ? false if assign_all else true
# store as {node_id: [[ls, ic, pl, al], [], [], ... ,[]]}
import json
from collections import Counter
# try:
#     with open('results/data_random_1000.txt', 'r') as datadict:
#         data = json.load(datadict)
# except IOError:
data = {}
lens_sizes = [8, 16, 32, 64]
centrals = [0, 1]
for is_central in centrals:
    for lens_size in lens_sizes:
        print lens_size, is_central
        if is_central:
            with open('results/run2/node_labels_random_1000_' + str(lens_size) + '.txt', 'r') as filedict:
                node_labels = json.load(filedict)
            for node_id in node_labels.keys():
                temp = node_id.split('_')
                prediction_label = node_labels[node_id]
                actual_label = temp[1][:2]

                vals = [lens_size, is_central, prediction_label[0], actual_label]
                new_temp = data.get(node_id, [[]])
                if not new_temp[0]:
                    new_temp[0] = vals
                else:
                    new_temp.append(vals)
                data[node_id] = new_temp
        else:
            with open('results/run6/node_labels_random_all_1000_' + str(lens_size) + '.txt', 'r') as filedict:
                node_labels = json.load(filedict)
            for node_id in node_labels.keys():
                temp = node_id.split('_')
                actual_label = temp[1][:2]

                prediction_labels = node_labels[node_id]

                # Old method of taking the most common:
                # if len(prediction_labels) > 1:
                #     pred_counter = Counter(prediction_labels[1:])
                #     prediction_label = pred_counter.most_common(1)[0][0]
                # else:
                #     prediction_label = prediction_labels[0]

                if len(prediction_labels) == 1:
                    continue

                vals = [lens_size, is_central] + prediction_labels + [actual_label]
                new_temp = data.get(node_id, [[]])
                if not new_temp[0]:
                    new_temp[0] = vals
                else:
                    new_temp.append(vals)
                data[node_id] = new_temp

with open('results/data_random_1000.txt', 'w') as datadict:
    datadict.write(json.dumps(data))
