# keep 8 counters: one for each (ls, ic) pair
# divide this counter by total number of nodes because each pair (see prev.) has one prediction for each node
# maximum number any counter could reach is the number of nodes
# this ratio is its weight

# now I have one prediction per pair and one weight per pair
# Use this to provide a top 3 prediction
import json
from collections import defaultdict
import operator
from collections import Counter
from matplotlib import pyplot as plt
import numpy as np


which = 'random'
targets = ['ci', 'fa', 'ro', 'we', 'wi', 'am', 'db', 'aq', 'go']
targets = set(targets)
counters = {8: 0, 9: 0, 16: 0, 17: 0, 32: 0, 33: 0, 64: 0, 65: 0}  # correct
tot_counters = {8: 0, 9: 0, 16: 0, 17: 0, 32: 0, 33: 0, 64: 0, 65: 0}  # (correct + incorrect)

with open('results/data_' + which + '_100.txt', 'r') as dr:
    data = json.load(dr)

# # Use only a part of the data to get the weights
# # Use 20% for testing, use the other 80% to get weights. on the test set, do the following:
# # top k - one graph for each k = 1, 2, 3:
# # 2 cases: at least one of the top k preds is above threshold; none of them are
# # 1st case: if it is correct: +1, if it is incorrect: +0, if below threshold: +random guess=1/9
# # keep track of #predictions as well. That vs acc. graph is also interesting to see
#
#
# # add entries in labels for 0 weights as well
# # Some analysis - weight vs position in the graph
#
data_items = data.items()
n_data = len(data_items)
percent = 0.8
idx = int(percent * n_data)
train = data_items[:idx]
test = data_items[idx:]
print len(train), len(test)

# # Works only for old method with one prediction per lens per node
# # for _, vals in train:
# #     for val in vals:
# #         counters[val[0] + val[1]] += int(val[2] == val[3])
# #         tot_counters[val[0] + val[1]] += 1

# for _, vals in train:
#     for val in vals:
#         if val[1]:
#             for pred in val[2:-1]:
#                 counters[val[0] + val[1]] += int(pred == val[-1])
#                 tot_counters[val[0] + val[1]] += 1
#         else:
#             # temp = Counter(val[2:-1])
#             # counters[val[0] + val[1]] += temp[val[-1]] * 1.0 / sum(temp.values())
#             # tot_counters[val[0] + val[1]] += 1
#             for pred in val[2:-1]:
#                 counters[val[0] + val[1]] += int(pred == val[-1])
#                 tot_counters[val[0] + val[1]] += 1

# # print counters
# # print tot_counters
# s = sum(counters.values())
# nodes = len(train)
# weights = {}
weights = {8: 0.04506219, 16: 0.13708503, 32: 0.11197231, 64: 0.01670342,
           9: 0.02881042, 17: 0.37935935, 33: 0.26598785, 65: 0.01501943}
#
# for key in counters.keys():
#     weights[key] = counters[key] * 1.0 / tot_counters[key]
# print weights
# exit(0)
# scipy test
# {8: 0.02910479, 16: 0.120274, 32: 0.13105132, 64: 0.02003091,
#  9: 0.05194279, 17: 0.37570876, 33: 0.25867688, 65: 0.01321054}

# scipy train
# {8: 0.04506219, 16: 0.13708503, 32: 0.11197231, 64: 0.01670342,
#  9: 0.02881042, 17: 0.37935935, 33: 0.26598785, 65: 0.01501943}

# {32: 0.33421842174048305, 65: 0.3065344195912071, 33: 0.3453408214423448,
# 8: 0.2754863072957796, 9: 0.29087929039722327, 64: 0.3064076816905054,
# 16: 0.32945532738933303, 17: 0.3395801195526417}

# linprog normalized:
# {8: 0.0484, 16: 0.15, 32: 0.15, 64: 0.0149,
#  9: 0.0923, 17: 0.2684, 33: 0.2658, 65: 0.0102}

# linprog non-normalized
# {8: 0.0, 16: 0.2037, 32: 0.3086, 64: 0.0062,
# 9: 0.0, 17: 0.1852, 33: 0.2693, 65: 0.0}

# frac of num_labels as correct (in counters{}) for non central methods
# {32: 0.31866686692187596, 65: 0.3065344195912071, 33: 0.3453408214423448,
# 8: 0.2799295289658227, 9: 0.29087929039722327, 64: 0.27475564974694555,
# 16: 0.32472106480624613, 17: 0.3395801195526417}

# print sum(weights.values())

# with open('results/counter.txt', 'w') as c:
#     c.write(json.dumps(counters))

# Old method:
# labels = {}
# for key, vals in test:
#     temp = defaultdict(int)
#     for val in vals:
#         temp[val[2]] += weights[val[0] + val[1]]
#         for z in (targets - set(temp.keys())):
#             temp[z] = 0
#     labels[key] = list(sum(sorted(temp.items(), key=operator.itemgetter(1), reverse=True), ())) + [vals[0][-1]]

labels = {}
for key, vals in data_items:
    temp = defaultdict(int)
    for val in vals:
        if val[1]:
            for pred in val[2:-1]:
                temp[pred] += weights[val[0] + val[1]]
        else:
            for pred in val[2:-1]:
                temp[pred] += weights[val[0] + val[1]]
        # Normalize
        nmlzer = sum(temp.values())
        if nmlzer > 0:
            for k in temp.keys():
                temp[k] /= nmlzer
        for z in (targets - set(temp.keys())):
            temp[z] = 0
    labels[key] = list(sum(sorted(temp.items(), key=operator.itemgetter(1), reverse=True), ())) + [vals[0][-1]]

with open('results/labels_all_' + which + '_100.txt', 'w') as c:
    c.write(json.dumps(labels))
# with open('results/labels_train_' + which + '_scipy_min.txt', 'w') as c:
#     c.write(json.dumps(labels))
# exit(0)
with open('results/labels_test_' + which + '_nomaj.txt', 'r') as nm:
    labels = json.load(nm)
# print len(test)
# print len(labels)
# tau = [x/10.0 for x in range(0, 11)]  # threshold
# with open('results/tau_' + which + '_train_scipy_min.txt', 'r') as t:
#     tau = json.load(t)
# tau = [0.0, 0.26902424005678943, 0.3, 0.4, 0.5, 1.0]
# tau = [0.0, 1.0]
# tau = [x * 0.001 for x in range(1001)]
tau = [0.2842316366729224]
correct = [0] * len(tau)
incorrect = [0] * len(tau)
alp = [0] * len(tau)
# test = []
count = 0
reward = {}
for j, t in enumerate(tau):
    print t
    for key, val in labels.items():
        act = val[-1]
        lbls = val[:-1][0::2]
        wghts = val[:-1][1::2]
        if t == 0:
            if act == lbls[0]:
                correct[j] += 1
                alp[j] += 1
            else:
                incorrect[j] += 1
                alp[j] += 1
        else:
            curr_confi, idx = 0, 0
            try:
                max_idx = wghts.index(0.0)
            except ValueError:
                max_idx = 9
            # max_idx = sum(nnz > 0 for nnz in wghts)
            while curr_confi < t and idx < max_idx:
                curr_confi += wghts[idx]
                idx += 1
            # How is 1.0 < 1.0 True?????!!!!!
            # if sum(wghts) < t and wghts[-1] == 0.0:
            #     print("%0.100f", sum(wghts))
            #     exit(0)
                # count += 1
            if act in lbls[:idx]:
                correct[j] += wghts[lbls[:idx].index(act)] / sum(wghts[:idx])
                # correct[j] += 1.0 / idx
                alp[j] += idx
                reward[key] = 1.0 / idx
                # test.append(idx)
            else:
                incorrect[j] += 1
                alp[j] += idx
                reward[key] = 0
                # test.append(idx)
    # preds = (correct + incorrect)
    # prod = (correct + miss/9.0)
    # print k, t, correct, incorrect, miss, prod/len(labels), prod/preds
reward_type = 'weight'
print correct
# exit(0)
# print test
# with open('results/reward_' + which + '_best_tau_train.txt', 'w') as t:
#     t.write(json.dumps(reward))
# with open('results/correct_' + which + '_scipy_min_100_' + reward_type + '_test.txt', 'w') as t:
#     t.write(json.dumps(correct))
with open('results/correct_' + which + '1000_' + reward_type + '_test.txt', 'w') as t:
    t.write(json.dumps(correct))
# with open('results/incorrect_' + which + '_reward_nomaj_weight.txt', 'w') as t:
#     t.write(json.dumps(incorrect))
# with open('results/miss_' + which + str(k) + '22.txt', 'w') as t:
#     t.write(json.dumps(miss))
# avlp = (alp[0] - count) * 1.0 / len(labels)
# print count, avlp
# exit(0)
avlp = [x * 1.0 / len(labels) for x in alp]
# print avlp[-1]
# print test[:100], avlp, len(labels)
# np.save('avlp.npy', np.array(test).astype('int32'))
# with open('results/ave_len_pred_set_' + which + '_scipy_min_100_' + reward_type + '_test.txt', 'w') as a:
#     a.write(json.dumps(avlp))
with open('results/ave_len_pred_set_' + which + '1000_' + reward_type + '_test.txt', 'w') as a:
    a.write(json.dumps(avlp))
# ccic = [x*1.0/(x+y) for x, y in zip(correct, incorrect)]
# plt.plot(tau, [y * 1.0 / 82976 for y in correct])
# plt.savefig('plot_test.pdf')
# plt.show()
# print count, miss
# print miss_dic
# print count * 1.0/nodes
