# Read the big graph
# Iterate through the list of nodes
# Perform a random walk from each node
# Sort the nodes in the walk
# Get the image of this sample
# Send it through the classifier that is loaded from the disk
# Apply the label to all of the nodes and save in a dict- old_label:[new_labels]
# Check how many nodes were correctly classified
import networkx as nx
from extract_random_walks import sample_random_walk as rw
from order_nodes import order_nodes as on
import sys
import numpy as np
from keras.models import model_from_json
# from collections import Counter
import json


def load_model(nodes):
    # load json and create model
    json_file = open('model' + str(nodes) + '.json', 'r')
    loaded_model_json = json_file.read()
    json_file.close()
    loaded_model = model_from_json(loaded_model_json)

    # load weights into new model
    loaded_model.load_weights('model' + str(nodes) + '.h5')
    print("Loaded model from disk")
    # out_file.write('Loaded model from disk' + '\n')
    return loaded_model


filename = '/gpfs/u/home/GPHC/GPHChegd/barn/source/big_graph_random_1000.txt'
# filename = 'data/big_graph_random_100.txt'
pre = '/gpfs/u/home/GPHC/GPHChegd/barn/'
# pre = ''
node_size = int(sys.argv[1])
oldseen = 600000
out_file = pre + 'results/out_predict_lens_' + str(node_size) + '_'
graph = nx.read_edgelist(filename)

try:
    with open(out_file + str(oldseen) + '.txt', 'r') as nl:
        node_labels = json.load(nl)
except IOError:
    node_labels = {}

model = load_model(node_size)
target = {0: 'ci', 1: 'fa', 2: 'ro', 3: 'we', 4: 'wi', 5: 'am', 6: 'db', 7: 'aq', 8: 'go'}
seen = 0

for node in graph.nodes():
    if node in node_labels:
        seen += 1
        continue
    seen += 1
    if seen % 100000 == 0:
        # out_file.write(str(seen) + '\n')
        # print seen
        with open(out_file + str(seen) + '.txt', 'w') as o:
            o.write(json.dumps(node_labels))
        # try:
        #     with open('out_predict_lens' + str(node_size) + str(seen) + '.pickle', 'wb') as handle:
        #         pickle.dump(node_labels, handle, protocol=pickle.HIGHEST_PROTOCOL)
        # except:
        #     pass
    edges = rw(graph, node, node_size)
    g = nx.from_edgelist(edges)
    # nx.write_edgelist(g, 'h.txt')
    # print g.nodes()
    ord_list = on(g)
    mat_g = np.asarray(nx.attr_matrix(g, rc_order=ord_list))
    # np.save('h.npy',mat_g)
    # exit(0)
    if len(mat_g) != node_size or len(mat_g[0]) != node_size:
        # out_file.write(str(seen) + '\n')
        print seen
        continue
    mat_g = np.reshape(mat_g, [1, 1, node_size, node_size])
    pred = model.predict(mat_g).argmax(1).astype('int32')
    # print pred
    temp = node_labels.get(node, [])
    temp.append(target[pred[0]])
    node_labels[node] = temp

# dicfile = 'raw_prediction' + str(node_size) + '.txt'
# dicfile2 = 'results/prediction_random_' + str(node_size) + '.txt'
# df = open(dicfile, 'w')
# df2 = open(dicfile2, 'w')

with open(pre + 'results/node_labels_random_1000_' + str(node_size) + '.txt', 'w') as filedict:
    filedict.write(json.dumps(node_labels))

# with open('results/node_labels' + str(node_size) + '.txt', 'r') as filedict:
#     node_labels = json.load(filedict)

# for k, v in node_labels.items():
#     v2 = [i for i in v]
#     if len(v) > 1:
#         # df.write(k + ', ' + ' '.join([str(vi) for vi in v]) + '\n')
#         data = Counter(v)
#         v2 = [data.most_common(1)[0][0]]
#         # print 'Hi'
#         # print v2
#         # exit(0)
#         node_labels[k] = v2
#     # df.write(k + ', ' + v[0] + '\n')
#     df2.write(k + ', ' + v2[0] + '\n')
#
# # df.close()
# df2.close()
#
# correct_preds = 0
# for k, v in node_labels.items():
#     idx = k.find('_')
#     label = k[idx+1:idx+3]
#     if label == v[0]:
#         correct_preds += 1
#
# # out_file.write(str(correct_preds) + '\n')
# # out_file.write(str(len(node_labels)) + '\n')
# print correct_preds, len(node_labels)
# acc = correct_preds * 1.0 / len(node_labels)
# print acc
# out_file.write(str(acc) + '\n')
# out_file.close()

# 8:
# 37199 103689
# 0.358755509263

# 16:
# 47418 102680
# 0.461803661862

# 32:
# 52061 100077
# 0.520209438732

# 64:
# 48539 95186
# 0.509938436325
