# ReadMe

This package uses the novel structured image embedding feature to perform node classification in topologically heterogeneous networks.  Given a network, you can classify its nodes into networks the model has been trained on. One of the applications of this tool is clustering.  Please see the cited papers for more details.

# Usage:
`cd network-lens`

`python driver.py`

# Config:
- Set the parameters as required in the `config.py` file and then run `driver.py` as shown above.

# Citations:
- Hegde, K., & Magdon-Ismail, M. (2018). Network Lens: Node Classification in Topologically Heterogeneous Networks.
- Hegde, K., Magdon-Ismail, M., Ramanathan, R., & Thapa, B. (2018). Network Signatures from Image Representation of Adjacency Matrices: Deep/Transfer Learning for Subgraph Classification. arXiv preprint arXiv:1804.06275.
- Wu, Ke, Philip Watters, and Malik Magdon-Ismail. "Network classification using adjacency matrix embeddings and deep learning." Advances in Social Networks Analysis and Mining (ASONAM), 2016 IEEE/ACM International Conference on. IEEE, 2016.

# Datasets:
- [Facebook](https://snap.stanford.edu/data/egonets-Facebook.html)
- J. McAuley and J. Leskovec. Learning to Discover Social Circles in Ego Networks. NIPS, 2012.
- [Road Network](https://snap.stanford.edu/data/roadNet-PA.html)
- J. Leskovec, K. Lang, A. Dasgupta, M. Mahoney. Community Structure in Large Networks: Natural Cluster Sizes and the Absence of Large Well-Defined Clusters. Internet Mathematics 6(1) 29--123, 2009.
